:- discontiguous male/1.
:- discontiguous female/1.
:- discontiguous parent/2.
:- discontiguous different/2.
:- encoding(utf8).


male('Владимир Ильич Ульянов(Ленин)').

parent('Илья Николаевич Ульянов', 'Владимир Ильич Ульянов(Ленин)'). 
male('Илья Николаевич Ульянов').
parent('Мария Александровна Бланк','Владимир Ильич Ульянов(Ленин)').
female('Мария Александровна Бланк').

parent('Николай Васильеич Ульянов', 'Илья Николаевич Ульянов').
male('Николай Васильеич Ульянов').
parent('Анна Алексеевна Смирнова', 'Илья Николаевич Ульянов').
female('Анна Алексеевна Смирнова').

parent('Василий Никитич Ульянов', 'Николай Васильеич Ульянов').
male('Василий Никитич Ульянов').
parent('Анна Семеновна Ульянина', 'Николай Васильеич Ульянов').
female('Анна Семеновна Ульянина').

parent('Никита Григорьевич Ульянов', 'Василий Никитич Ульянов').
male('Никита Григорьевич Ульянов').

parent('Григорий Андреевич Ульянин', 'Никита Григорьевич Ульянов').
male('Григорий Андреевич Ульянин').

parent('Андрей Ульянин', 'Григорий Андреевич Ульянин').
male('Андрей Ульянин').

parent('Алексей Лукьянович Смирнов','Анна Алексеевна Смирнова').
male('Алексей Лукьянович Смирнов').

parent('Лукьян Смирнов', 'Алексей Лукьянович Смирнов').
male('Лукьян Смирнов').

parent('Израил Мойшевич Бланк', 'Мария Александровна Бланк').
male('Израил Мойшевич Бланк').
parent('Анна Иоганновна Гроссшопф', 'Мария Александровна Бланк').
female('Анна Иоганновна Гроссшопф').

parent('Дмитрий Бланк', 'Израил Мойшевич Бланк').
male('Дмитрий Бланк').
parent('Марьям Фроимович', 'Израил Мойшевич Бланк').
female('Марьям Фроимович').

parent('Ицык Бланк', 'Дмитрий Бланк').
male('Ицык Бланк').

parent('Иоганн Готтлиб Гроссшопф', 'Анна Иоганновна Гроссшопф').
male('Иоганн Готтлиб Гроссшопф').
parent('Анна Беатта Эстедт', 'Анна Иоганновна Гроссшопф').
female('Анна Беатта Эстедт').

parent('Кристоф Фридрих Гроссшопф', 'Иоганн Готтлиб Гроссшопф').
male('Кристоф Фридрих Гроссшопф').
parent('Христина Маргарет Эдлер', 'Иоганн Готтлиб Гроссшопф').
female('Христина Маргарет Эдлер').

parent('Иоахим Эрнст Гроссшопф', 'Кристоф Фридрих Гроссшопф').
male('Иоахим Эрнст Гроссшопф').
parent('Абель Кристина Гюттнер', 'Кристоф Фридрих Гроссшопф').
female('Абель Кристина Гюттнер').

parent('Иоганн Андреас Гюттнер', 'Абель Кристина Гюттнер').
male('Иоганн Андреас Гюттнер').

parent('Иоганн Эдлер', 'Христина Маргарет Эдлер').
male('Иоганн Эдлер').

parent('Карл Фредерик Эстедт', 'Анна Беатта Эстедт').
male('Карл Фредерик Эстедт').
parent('Анна Кристина Борг', 'Анна Беатта Эстедт').
female('Анна Кристина Борг').

parent('Карл Рейнгольд Эстедт', 'Карл Фредерик Эстедт').
male('Карл Рейнгольд Эстедт').
parent('Беатта Элеонора Ниман', 'Карл Фредерик Эстедт').
female('Беатта Элеонора Ниман').

parent('Карп Ниман', 'Беатта Элеонора Ниман').
male('Карп Ниман').
parent('Беата Далфил', 'Беатта Элеонора Ниман').
female('Беата Далфил').

parent('Петер Карлон Ниман', 'Карп Ниман').
male('Петер Ниман').
parent('Мария Хоок', 'Карп Ниман').
female('Мария Хоок').

parent('Петер Далфил', 'Беата Далфил').
male('Петер Далфил').

parent('Карл Персон Борг', 'Анна Кристина Борг').
male('Карл Персон Борг').
parent('Анна Бригита Новелия', 'Анна Кристина Борг').
female('Анна Бригита Новелия').

parent('Пер Монссон', 'Карл Персон Борг').
male('Пер Монссон').
parent('Карин Кнутдоттер', 'Карл Персон Борг').
female('Карин Кнутдоттер').

parent('Кнут Боргхулт', 'Карин Кнутдоттер').
male('Кнут Боргхулт').

parent('Симон Новелиус', 'Анна Бригита Новелия').
male('Симон Новелиус').
parent('Катарина Арнберг', 'Анна Бригита Новелия').
female('Катарина Арнберг').

parent('Эрик Бертипсон', 'Симон Новелиус').
male('Эрик Бертипсон').
parent('Керстин Хансдоттер', 'Симон Новелиус').
female('Керстин Хансдоттер').

parent('Бертил Ионсон', 'Эрик Бертипсон').
male('Бертил Ионсон').

parent('Эрик Эриксон', 'Катарина Арнберг').
male('Эрик Эриксон').

father(X, Y) :- parent(X, Y), male(X).
mother(X, Y) :- parent(X, Y), female(X).
grandparent(X,Y) :- parent(X,Z), parent(Z,Y).
predecessor(X,Y) :- parent(X,Y).
predecessor(X,Y) :- parent(X,Z), predecessor(Z,Y).
husband(X,Y) :- parent(X,Z), parent(Y,Z), X \= Y.
brother(X,Y) :- parent(Z,X), parent(Z,Y), male(X), male(Y), X \= Y.
sister(X,Y) :- parent(Z,X), parent(Z,Y), female(X), female(Y), X \= Y.
sibling(X,Y) :- parent(Z,X), parent(Z,Y), X \= Y.
uncle(X,Y) :- male(X), parent(Z,Y), sibling(X,Z).
aunt(X, Y) :- female(X), parent(Z,Y), sibling(X,Z).

?- predecessor(X, 'Симон Новелиус'), write(X).